SCREEN 13 ' (320x200)
_TITLE "2D ROAD engine"
'_FULLSCREEN

' engine by F.L from lou gorenfeld example : http://www.gorenfeld.net/lou/pseudo/
' to run with qb64 : http://www.qb64.net/


CONST RoadLines = 66
SpeedScroll = 5
CONST RoadY = -1 'arbitrary
CONST ResX = 320
CONST ResY = 200
CONST PlrLine = 8 '  ??
DIM ZMap(RoadLines) AS SINGLE


horizon = 134


' Initialize ZMap
FOR A = 1 TO RoadLines
    ZMap(A) = RoadY / (A - (ResY / 2))
NEXT A

' Normalize ZMap so the line with the player on it is scale=1 (or would be
' If we had a player sprite :))  ' ??
b = 1 / ZMap(PlrLine)
b = b * 300 '                    height of road strips
FOR A = 1 TO RoadLines
    ZMap(A) = ZMap(A) * b
NEXT A


' Draw the road
DIM X AS SINGLE
DIM DX AS SINGLE
DIM DDX AS SINGLE
DIM HalfWidth AS SINGLE
DIM SegY AS SINGLE

TexOffset = 100
SegY = RoadLines
DX = 0
DDX = -.05 ' angle of turn

'           main loop

DO

    HalfWidth = 160 '  width of road
    WidthStep = 2.3 '  inclination of the straight road

    '                               keyboard  input

    IF _KEYDOWN(19712) THEN DDX = -.05
    IF _KEYDOWN(19200) THEN DDX = .05

    IF _KEYDOWN(20480) THEN SegY = SegY + 1
    IF _KEYDOWN(18432) THEN SegY = SegY - 1

    '                           limits of the turn


    IF SegY < 0 THEN SegY = 0
    IF SegY > RoadLines THEN SegY = RoadLines

    ' Set up the frame

    X = 160 ' center of road

    DX = 0 ' try 1 or -1 to change the side the road


    ScreenLine = ResY - 1

    FOR A = 1 TO RoadLines
        IF (ZMap(A) + TexOffset) MOD 100 > 50 THEN
            GrassColor = 10
            RoadColor = 7
        ELSE
            GrassColor = 2
            RoadColor = 8
        END IF

        ' road

        LINE (X - HalfWidth, ScreenLine)-(X + HalfWidth, ScreenLine), RoadColor

        ' left grass
        LINE (0, ScreenLine)-(X - HalfWidth, ScreenLine), GrassColor

        ' right grass
        LINE (X + HalfWidth, ScreenLine)-(320, ScreenLine), GrassColor


        HalfWidth = HalfWidth - WidthStep
        ScreenLine = ScreenLine - 1

        IF A > SegY THEN
            DX = DX + DDX
        END IF

        X = X + DX

    NEXT A

    ' Wrap positions (fractional):

    TexOffset = TexOffset + SpeedScroll
    WHILE TexOffset >= 100
        TexOffset = TexOffset - 100
    WEND


    ' background display

    LINE (0, 0)-(320, horizon - 1), 9, BF


    '  others display

    COLOR 15, 9

    LOCATE 1, 1: PRINT "esc to exit"
    LOCATE 2, 1: PRINT "up-down :  do the curve"
    LOCATE 3, 1: PRINT "left-right : change the direction"
    LOCATE 7, 10: PRINT "turn to the"

    COLOR 4, 9
    IF DDX = -.05 THEN LOCATE 7, 22: PRINT "right"
    IF DDX = .05 THEN LOCATE 7, 22: PRINT "left"

    _LIMIT 50

    _DISPLAY

    IF _KEYDOWN(27) THEN END

LOOP

